"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer = __importStar(require("inquirer"));
const init_1 = require("@specron/init");
const reporter_1 = require("@hayspec/reporter");
const env_1 = require("../lib/env");
function default_1(argv) {
    return __awaiter(this, void 0, void 0, function* () {
        const config = env_1.getConfig(argv);
        const root = process.cwd();
        const printer = new reporter_1.Printer();
        let answers = {};
        if (!(config.name && config.description)) {
            answers = yield inquirer.prompt([
                {
                    type: 'input',
                    name: 'name',
                    message: "Project name:",
                    default: config.name || 'myproject',
                },
                {
                    type: 'input',
                    name: 'description',
                    message: "Project description:",
                    default: config.description || '.',
                },
            ]);
        }
        else {
            answers = {
                name: config.name,
                description: config.description,
            };
        }
        const generator = new init_1.Generator({
            root,
            name: (answers['name'] || process.cwd().split(/\\|\//).reverse()[0]).toLowerCase(),
            description: answers['description'],
        });
        try {
            yield generator.build();
            printer.end(printer.indent(1, ''), `Continue by running the commands below:`);
            printer.end(printer.indent(2, ''), printer.colorize('gray', `$ npm install`));
            printer.end(printer.indent(2, ''), printer.colorize('gray', `$ npm test`));
            printer.end();
            process.exit(0);
        }
        catch (e) {
            console.error(e);
            process.exit(2);
        }
    });
}
exports.default = default_1;
//# sourceMappingURL=init.js.map